
Index: usr.bin/procstat/procstat.c
===================================================================
--- usr.bin/procstat/procstat.c	(.../stable/8)	(revision 201781)
+++ usr.bin/procstat/procstat.c	(.../projects/capabilities8)	(revision 205872)
@@ -39,14 +39,14 @@
 #include "procstat.h"
 
 static int aflag, bflag, cflag, fflag, kflag, sflag, tflag, vflag;
-int	hflag;
+int	hflag, Cflag;
 
 static void
 usage(void)
 {
 
-	fprintf(stderr, "usage: procstat [-h] [-w interval] [-b | -c | -f | "
-	    "-k | -s | -t | -v]\n");
+	fprintf(stderr, "usage: procstat [-hC] [-w interval] [-b | -c | -f "
+	    " | -k | -s | -t | -v]\n");
 	fprintf(stderr, "                [-a | pid ...]\n");
 	exit(EX_USAGE);
 }
@@ -109,7 +109,7 @@
 	char *dummy;
 
 	interval = 0;
-	while ((ch = getopt(argc, argv, "abcfkhstvw:")) != -1) {
+	while ((ch = getopt(argc, argv, "abcfkhstvw:C")) != -1) {
 		switch (ch) {
 		case 'a':
 			aflag++;
@@ -156,6 +156,10 @@
 			interval = l;
 			break;
 
+		case 'C':
+			Cflag++;
+			break;
+
 		case '?':
 		default:
 			usage();
@@ -178,6 +182,10 @@
 	if (!(aflag == 1 && argc == 0) && !(aflag == 0 && argc > 0))
 		usage();
 
+	/* Only allow -C with -f. */
+	if (Cflag && !fflag)
+		usage();
+
 	do {
 		if (aflag) {
 			name[0] = CTL_KERN;
Index: usr.bin/procstat/procstat_files.c
===================================================================
--- usr.bin/procstat/procstat_files.c	(.../stable/8)	(revision 201781)
+++ usr.bin/procstat/procstat_files.c	(.../projects/capabilities8)	(revision 205872)
@@ -1,5 +1,5 @@
 /*-
- * Copyright (c) 2007 Robert N. M. Watson
+ * Copyright (c) 2007-2009 Robert N. M. Watson
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -27,6 +27,7 @@
  */
 
 #include <sys/param.h>
+#include <sys/capability.h>
 #include <sys/socket.h>
 #include <sys/sysctl.h>
 #include <sys/un.h>
@@ -131,24 +132,146 @@
 	printf("%s", addr);
 }
 
+static struct cap_desc {
+	cap_rights_t	 cd_right;
+	const char	*cd_desc;
+} cap_desc[] = {
+	{ CAP_READ,		"rd" },
+	{ CAP_WRITE,		"wr" },
+	{ CAP_SEEK,		"se" },
+	{ CAP_GETPEERNAME,	"pn" },
+	{ CAP_GETSOCKNAME,	"sn" },
+	{ CAP_FCHFLAGS,		"cf" },
+	{ CAP_IOCTL,		"io" },
+	{ CAP_FSTAT,		"fs" },
+	{ CAP_MMAP,		"mm" },
+	{ CAP_FCNTL,		"fc" },
+	{ CAP_EVENT,		"ev" },
+	{ CAP_FSYNC,		"fy" },
+	{ CAP_FCHOWN,		"cn" },
+	{ CAP_FCHMOD,		"cm" },
+	{ CAP_FTRUNCATE,	"ft" },
+	{ CAP_FLOCK,		"fl" },
+	{ CAP_FSTATFS,		"sf" },
+	{ CAP_REVOKE,		"rv" },
+	{ CAP_FEXECVE,		"fe" },
+	{ CAP_FPATHCONF,	"fp" },
+	{ CAP_FUTIMES,		"fu" },
+	{ CAP_ACL_GET,		"ag" },
+	{ CAP_ACL_SET,		"as" },
+	{ CAP_ACL_DELETE,	"ad" },
+	{ CAP_ACL_CHECK,	"ac" },
+	{ CAP_EXTATTR_GET,	"eg" },
+	{ CAP_EXTATTR_SET,	"es" },
+	{ CAP_EXTATTR_DELETE,	"ed" },
+	{ CAP_EXTATTR_LIST,	"el" },
+	{ CAP_MAC_GET,		"mg" },
+	{ CAP_MAC_SET,		"ms" },
+	{ CAP_ACCEPT,		"at" },
+	{ CAP_BIND,		"bd" },
+	{ CAP_GETSOCKOPT,	"gs" },
+	{ CAP_SETSOCKOPT,	"ss" },
+	{ CAP_LISTEN,		"ln" },
+	{ CAP_SHUTDOWN,		"sh" },
+	{ CAP_PEELOFF,		"pf" },
+	{ CAP_LOOKUP,		"lo" },
+	{ CAP_SEM_POST,		"sp" },
+	{ CAP_SEM_WAIT,		"sw" },
+	{ CAP_SEM_GETVALUE,	"sg" },
+	{ CAP_KEVENT,		"ke" },
+	{ CAP_PDGETPID,		"pg" },
+	{ CAP_PDWAIT,		"pw" },
+	{ CAP_PDKILL,		"pk" },
+};
+static const u_int	cap_desc_count = sizeof(cap_desc) /
+			    sizeof(cap_desc[0]);
+
+static u_int
+width_capability(cap_rights_t rights)
+{
+	u_int count, i, width;
+
+	count = 0;
+	width = 0;
+	for (i = 0; i < cap_desc_count; i++) {
+		if (rights & cap_desc[i].cd_right) {
+			width += strlen(cap_desc[i].cd_desc);
+			if (count)
+				width++;
+			count++;
+		}
+	}
+	return (width);
+}
+
+static void
+print_capability(cap_rights_t rights, u_int capwidth)
+{
+	u_int count, i, width;
+
+	count = 0;
+	width = 0;
+	for (i = width_capability(rights); i < capwidth; i++) {
+		if (rights || i != (capwidth - 1))
+			printf(" ");
+		else
+			printf("-");
+	}
+	for (i = 0; i < cap_desc_count; i++) {
+		if (rights & cap_desc[i].cd_right) {
+			printf("%s%s", count ? "," : "", cap_desc[i].cd_desc);
+			width += strlen(cap_desc[i].cd_desc);
+			if (count)
+				width++;
+			count++;
+		}
+	}
+}
+
 void
 procstat_files(pid_t pid, struct kinfo_proc *kipp)
 {
 	struct kinfo_file *freep, *kif;
+	u_int capwidth, width;
 	int i, cnt;
 	const char *str;
 
-	if (!hflag)
-		printf("%5s %-16s %4s %1s %1s %-8s %3s %7s %-3s %-12s\n",
-		    "PID", "COMM", "FD", "T", "V", "FLAGS", "REF", "OFFSET",
-		    "PRO", "NAME");
+	/*
+	 * To print the header in capability mode, we need to know the width
+	 * of the widest capability string.  Even if we get no processes
+	 * back, we will print the header, so we defer aborting due to a lack
+	 * of processes until after the header logic.
+	 */
+	capwidth = 0;
+	freep = kinfo_getfile(pid, &cnt);
+	if (freep != NULL && Cflag) {
+		for (i = 0; i < cnt; i++) {
+			kif = &freep[i];
+			width = width_capability(kif->kf_cap_rights);
+			if (width > capwidth)
+				capwidth = width;
+		}
+		if (capwidth < strlen("CAPABILITIES"))
+			capwidth = strlen("CAPABILITIES");
+	}
 
-	freep = kinfo_getfile(pid, &cnt);
+	if (!hflag) {
+		if (Cflag)
+			printf("%5s %-16s %4s %1s %9s %-*s "
+			    "%-3s %-12s\n", "PID", "COMM", "FD", "T",
+			    "FLAGS", capwidth, "CAPABILITIES", "PRO",
+			    "NAME");
+		else
+			printf("%5s %-16s %4s %1s %1s %-9s %3s %7s %-3s "
+			    "%-12s\n", "PID", "COMM", "FD", "T", "V",
+			    "FLAGS", "REF", "OFFSET", "PRO", "NAME");
+	}
+
 	if (freep == NULL)
 		return;
 	for (i = 0; i < cnt; i++) {
 		kif = &freep[i];
-		
+
 		printf("%5d ", pid);
 		printf("%-16s ", kipp->ki_comm);
 		switch (kif->kf_fd) {
@@ -209,6 +332,10 @@
 			str = "e";
 			break;
 
+		case KF_TYPE_PROCDESC:
+			str = "P";
+			break;
+
 		case KF_TYPE_NONE:
 		case KF_TYPE_UNKNOWN:
 		default:
@@ -216,49 +343,51 @@
 			break;
 		}
 		printf("%1s ", str);
-		str = "-";
-		if (kif->kf_type == KF_TYPE_VNODE) {
-			switch (kif->kf_vnode_type) {
-			case KF_VTYPE_VREG:
-				str = "r";
-				break;
+		if (!Cflag) {
+			str = "-";
+			if (kif->kf_type == KF_TYPE_VNODE) {
+				switch (kif->kf_vnode_type) {
+				case KF_VTYPE_VREG:
+					str = "r";
+					break;
 
-			case KF_VTYPE_VDIR:
-				str = "d";
-				break;
+				case KF_VTYPE_VDIR:
+					str = "d";
+					break;
 
-			case KF_VTYPE_VBLK:
-				str = "b";
-				break;
+				case KF_VTYPE_VBLK:
+					str = "b";
+					break;
 
-			case KF_VTYPE_VCHR:
-				str = "c";
-				break;
+				case KF_VTYPE_VCHR:
+					str = "c";
+					break;
 
-			case KF_VTYPE_VLNK:
-				str = "l";
-				break;
+				case KF_VTYPE_VLNK:
+					str = "l";
+					break;
 
-			case KF_VTYPE_VSOCK:
-				str = "s";
-				break;
+				case KF_VTYPE_VSOCK:
+					str = "s";
+					break;
 
-			case KF_VTYPE_VFIFO:
-				str = "f";
-				break;
+				case KF_VTYPE_VFIFO:
+					str = "f";
+					break;
 
-			case KF_VTYPE_VBAD:
-				str = "x";
-				break;
+				case KF_VTYPE_VBAD:
+					str = "x";
+					break;
 
-			case KF_VTYPE_VNON:
-			case KF_VTYPE_UNKNOWN:
-			default:
-				str = "?";
-				break;
+				case KF_VTYPE_VNON:
+				case KF_VTYPE_UNKNOWN:
+				default:
+					str = "?";
+					break;
+				}
 			}
+			printf("%1s ", str);
 		}
-		printf("%1s ", str);
 		printf("%s", kif->kf_flags & KF_FLAG_READ ? "r" : "-");
 		printf("%s", kif->kf_flags & KF_FLAG_WRITE ? "w" : "-");
 		printf("%s", kif->kf_flags & KF_FLAG_APPEND ? "a" : "-");
@@ -266,28 +395,52 @@
 		printf("%s", kif->kf_flags & KF_FLAG_FSYNC ? "f" : "-");
 		printf("%s", kif->kf_flags & KF_FLAG_NONBLOCK ? "n" : "-");
 		printf("%s", kif->kf_flags & KF_FLAG_DIRECT ? "d" : "-");
-		printf("%s ", kif->kf_flags & KF_FLAG_HASLOCK ? "l" : "-");
-		if (kif->kf_ref_count > -1)
-			printf("%3d ", kif->kf_ref_count);
-		else
-			printf("%3c ", '-');
-		if (kif->kf_offset > -1)
-			printf("%7jd ", (intmax_t)kif->kf_offset);
-		else
-			printf("%7c ", '-');
+		printf("%s", kif->kf_flags & KF_FLAG_HASLOCK ? "l" : "-");
+		printf("%s ", kif->kf_flags & KF_FLAG_CAPABILITY ? "c" : "-");
+		if (!Cflag) {
+			if (kif->kf_ref_count > -1)
+				printf("%3d ", kif->kf_ref_count);
+			else
+				printf("%3c ", '-');
+			if (kif->kf_offset > -1)
+				printf("%7jd ", (intmax_t)kif->kf_offset);
+			else
+				printf("%7c ", '-');
+		}
 
+		if (Cflag) {
+			print_capability(kif->kf_cap_rights, capwidth);
+			printf(" ");
+		}
+
 		switch (kif->kf_type) {
 		case KF_TYPE_VNODE:
 		case KF_TYPE_FIFO:
 		case KF_TYPE_PTS:
 			printf("%-3s ", "-");
-			printf("%-18s", kif->kf_path);
 			break;
 
 		case KF_TYPE_SOCKET:
 			printf("%-3s ",
 			    protocol_to_string(kif->kf_sock_domain,
 			    kif->kf_sock_type, kif->kf_sock_protocol));
+			break;
+
+		case KF_TYPE_PROCDESC:
+			printf("%-3s %d", "-", kif->kf_pid);
+			break;
+
+		default:
+			printf("%-3s ", "-");
+		}
+
+		switch (kif->kf_type) {
+		case KF_TYPE_VNODE:
+		case KF_TYPE_FIFO:
+		case KF_TYPE_PTS:
+			printf("%-18s", kif->kf_path);
+
+		case KF_TYPE_SOCKET:
 			/*
 			 * While generally we like to print two addresses,
 			 * local and peer, for sockets, it turns out to be
@@ -310,8 +463,11 @@
 			}
 			break;
 
+		case KF_TYPE_PROCDESC:
+			printf("%d", kif->kf_pid);
+			break;
+
 		default:
-			printf("%-3s ", "-");
 			printf("%-18s", "-");
 		}
 
Index: usr.bin/procstat/procstat.h
===================================================================
--- usr.bin/procstat/procstat.h	(.../stable/8)	(revision 201781)
+++ usr.bin/procstat/procstat.h	(.../projects/capabilities8)	(revision 205872)
@@ -29,7 +29,7 @@
 #ifndef PROCSTAT_H
 #define	PROCSTAT_H
 
-extern int	hflag;
+extern int	hflag, Cflag;
 
 struct kinfo_proc;
 void	kinfo_proc_sort(struct kinfo_proc *kipp, int count);
Index: usr.bin/procstat/procstat_cred.c
===================================================================
--- usr.bin/procstat/procstat_cred.c	(.../stable/8)	(revision 201781)
+++ usr.bin/procstat/procstat_cred.c	(.../projects/capabilities8)	(revision 205872)
@@ -1,5 +1,5 @@
 /*-
- * Copyright (c) 2007 Robert N. M. Watson
+ * Copyright (c) 2007-2008 Robert N. M. Watson
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -47,9 +47,9 @@
 	gid_t *groups = NULL;
 
 	if (!hflag)
-		printf("%5s %-16s %5s %5s %5s %5s %5s %5s %-20s\n", "PID",
+		printf("%5s %-16s %5s %5s %5s %5s %5s %5s %4s %-15s\n", "PID",
 		    "COMM", "EUID", "RUID", "SVUID", "EGID", "RGID", "SVGID",
-		    "GROUPS");
+		    "FLAG", "GROUPS");
 
 	printf("%5d ", pid);
 	printf("%-16s ", kipp->ki_comm);
@@ -59,6 +59,8 @@
 	printf("%5d ", kipp->ki_groups[0]);
 	printf("%5d ", kipp->ki_rgid);
 	printf("%5d ", kipp->ki_svgid);
+	printf("%s", kipp->ki_cr_flags & CRED_FLAG_CAPMODE ? "C" : "-");
+	printf("    ");
 
 	/*
 	 * We may have too many groups to fit in kinfo_proc's statically
Index: usr.bin/netstat/unix.c
===================================================================
--- usr.bin/netstat/unix.c	(.../stable/8)	(revision 201781)
+++ usr.bin/netstat/unix.c	(.../projects/capabilities8)	(revision 205872)
@@ -193,21 +193,37 @@
 }
 
 void
-unixpr(u_long count_off, u_long gencnt_off, u_long dhead_off, u_long shead_off)
+unixpr(u_long count_off, u_long gencnt_off, u_long dhead_off, u_long shead_off,
+    u_long sphead_off)
 {
 	char 	*buf;
 	int	ret, type;
 	struct	xsocket *so;
 	struct	xunpgen *xug, *oxug;
 	struct	xunpcb *xunp;
+	u_long	head_off;
 
 	for (type = SOCK_STREAM; type <= SOCK_SEQPACKET; type++) {
 		if (live)
 			ret = pcblist_sysctl(type, &buf);
-		else
-			ret = pcblist_kvm(count_off, gencnt_off,
-			    type == SOCK_STREAM ? shead_off :
-			    (type == SOCK_DGRAM ? dhead_off : 0), &buf);
+		else {
+			head_off = 0;
+			switch (type) {
+			case SOCK_STREAM:
+				head_off = shead_off;
+				break;
+
+			case SOCK_DGRAM:
+				head_off = dhead_off;
+				break;
+
+			case SOCK_SEQPACKET:
+				head_off = sphead_off;
+				break;
+			}
+			ret = pcblist_kvm(count_off, gencnt_off, head_off,
+			    &buf);
+		}
 		if (ret == -1)
 			continue;
 		if (ret < 0)
Index: usr.bin/netstat/main.c
===================================================================
--- usr.bin/netstat/main.c	(.../stable/8)	(revision 201781)
+++ usr.bin/netstat/main.c	(.../projects/capabilities8)	(revision 205872)
@@ -184,6 +184,8 @@
 	{ .n_name = "_sctpstat" },
 #define	N_MFCTABLESIZE	54
 	{ .n_name = "_mfctablesize" },
+#define	N_UNP_SPHEAD    55
+	{ .n_name = "unp_sphead" },
 	{ .n_name = NULL },
 };
 
@@ -597,7 +599,8 @@
 #endif /* NETGRAPH */
 	if ((af == AF_UNIX || af == AF_UNSPEC) && !sflag)
 		unixpr(nl[N_UNP_COUNT].n_value, nl[N_UNP_GENCNT].n_value,
-		    nl[N_UNP_DHEAD].n_value, nl[N_UNP_SHEAD].n_value);
+		    nl[N_UNP_DHEAD].n_value, nl[N_UNP_SHEAD].n_value,
+		    nl[N_UNP_SPHEAD].n_value);
 	exit(0);
 }
 
Index: usr.bin/netstat/netstat.h
===================================================================
--- usr.bin/netstat/netstat.h	(.../stable/8)	(revision 201781)
+++ usr.bin/netstat/netstat.h	(.../projects/capabilities8)	(revision 205872)
@@ -149,7 +149,7 @@
 void	netgraphprotopr(u_long, const char *, int, int);
 #endif
 
-void	unixpr(u_long, u_long, u_long, u_long);
+void	unixpr(u_long, u_long, u_long, u_long, u_long);
 
 void	esis_stats(u_long, const char *, int, int);
 void	clnp_stats(u_long, const char *, int, int);

Index: usr.bin/gzip/gzsandbox.c
===================================================================
--- usr.bin/gzip/gzsandbox.c	(.../stable/8)	(revision 0)
+++ usr.bin/gzip/gzsandbox.c	(.../projects/capabilities8)	(revision 205872)
@@ -0,0 +1,409 @@
+/*-
+ * Copyright (c) 2009-2010 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * WARNING: THIS IS EXPERIMENTAL SECURITY SOFTWARE THAT MUST NOT BE RELIED
+ * ON IN PRODUCTION SYSTEMS.  IT WILL BREAK YOUR SOFTWARE IN NEW AND
+ * UNEXPECTED WAYS.
+ * 
+ * This software was developed at the University of Cambridge Computer
+ * Laboratory with support from a grant from Google, Inc. 
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <sys/cdefs.h>
+__FBSDID("$FreeBSD$");
+
+#include <sys/types.h>
+#include <sys/capability.h>
+#include <sys/uio.h>
+
+#include <err.h>
+#include <errno.h>
+#include <fcntl.h>
+#include <libcapsicum.h>
+#include <limits.h>
+#include <stdlib.h>
+#include <string.h>
+#include <unistd.h>
+
+#include "gzip.h"
+
+#define	LC_USR_BIN_GZIP_SANDBOX	"/usr/bin/gzip"
+
+#ifndef NO_SANDBOX_SUPPORT
+
+static char *lc_sandbox_argv[] = { __DECONST(char *, LC_USR_BIN_GZIP_SANDBOX),
+				    NULL };
+
+#define	PROXIED_GZ_COMPRESS	1
+#define	PROXIED_GZ_UNCOMPRESS	2
+#define	PROXIED_UNBZIP2		3
+
+static struct lc_sandbox	*lcsp;
+static int			 gzsandbox_initialized;
+static int			 gzsandbox_enabled;
+
+static void
+gzsandbox_initialize(void)
+{
+
+	if (gzsandbox_initialized)
+		return;
+	gzsandbox_enabled = lch_autosandbox_isenabled("gzip");
+	gzsandbox_initialized = 1;
+	if (!gzsandbox_enabled)
+		return;
+
+	if (lch_start(LC_USR_BIN_GZIP_SANDBOX, lc_sandbox_argv,
+	    LCH_PERMIT_STDERR, NULL, &lcsp) < 0)
+		err(-1, "lch_start %s", LC_USR_BIN_GZIP_SANDBOX);
+}
+
+struct host_gz_compress_req {
+	char		hgc_req_origname[PATH_MAX];
+	int		hgc_req_numflag;
+	uint32_t	hgc_req_mtime;
+} __packed;
+
+struct host_gz_compress_rep {
+	off_t	hgc_rep_gsize;
+	off_t	hgc_rep_retval;
+} __packed;
+
+static off_t
+gz_compress_insandbox(int in, int out, off_t *gsizep, const char *origname,
+    uint32_t mtime)
+{
+	struct host_gz_compress_req req;
+	struct host_gz_compress_rep rep;
+	struct iovec iov_req, iov_rep;
+	int fdarray[2];
+	size_t len;
+
+	bzero(&req, sizeof(req));
+	strlcpy(req.hgc_req_origname, origname,
+	    sizeof(req.hgc_req_origname));
+	req.hgc_req_numflag = numflag;
+	req.hgc_req_mtime = mtime;
+	iov_req.iov_base = &req;
+	iov_req.iov_len = sizeof(req);
+	iov_rep.iov_base = &rep;
+	iov_rep.iov_len = sizeof(rep);
+	fdarray[0] = cap_new(in, CAP_FSTAT | CAP_READ | CAP_SEEK);
+	fdarray[1] = cap_new(out, CAP_FSTAT | CAP_WRITE | CAP_SEEK);
+	if (fdarray[0] == -1 || fdarray[1] == -1)
+		err(-1, "cap_new");
+	if (lch_rpc_rights(lcsp, PROXIED_GZ_COMPRESS, &iov_req, 1,
+	    fdarray, 2, &iov_rep, 1, &len, NULL, NULL) < 0)
+		err(-1, "lch_rpc_rights");
+	if (len != sizeof(rep))
+		errx(-1, "lch_rpc_rights len %zu", len);
+	if (gsizep != NULL)
+		*gsizep = rep.hgc_rep_gsize;
+	close(fdarray[0]);
+	close(fdarray[1]);
+	return (rep.hgc_rep_retval);
+}
+
+static void
+sandbox_gz_compress_buffer(struct lc_host *lchp, uint32_t opno,
+    uint32_t seqno, char *buffer, size_t len, int fd_in, int fd_out)
+{
+	struct host_gz_compress_req req;
+	struct host_gz_compress_rep rep;
+	struct iovec iov;
+
+	if (len != sizeof(req))
+		err(-1, "sandbox_gz_compress_buffer: len %zu", len);
+
+	bcopy(buffer, &req, sizeof(req));
+	bzero(&rep, sizeof(rep));
+	numflag = req.hgc_req_numflag;
+	rep.hgc_rep_retval = gz_compress(fd_in, fd_out, &rep.hgc_rep_gsize,
+	    req.hgc_req_origname, req.hgc_req_mtime);
+	iov.iov_base = &rep;
+	iov.iov_len = sizeof(rep);
+	if (lcs_sendrpc(lchp, opno, seqno, &iov, 1) < 0)
+		err(-1, "lcs_sendrpc");
+}
+
+off_t
+gz_compress_wrapper(int in, int out, off_t *gsizep, const char *origname,
+    uint32_t mtime)
+{
+
+	gzsandbox_initialize();
+	if (gzsandbox_enabled)
+		return (gz_compress_insandbox(in, out, gsizep, origname,
+		    mtime));
+	else
+		return (gz_compress(in, out, gsizep, origname, mtime));
+}
+
+struct host_gz_uncompress_req {
+	size_t	hgu_req_prelen;
+	char	hgu_req_filename[PATH_MAX];
+	/* ... followed by data ... */
+};
+
+struct host_gz_uncompress_rep {
+	off_t	hgu_rep_gsize;
+	off_t	hgu_rep_retval;
+};
+
+static off_t
+gz_uncompress_insandbox(int in, int out, char *pre, size_t prelen,
+    off_t *gsizep, const char *filename)
+{
+	struct host_gz_uncompress_req req;
+	struct host_gz_uncompress_rep rep;
+	struct iovec iov_req[2], iov_rep;
+	int fdarray[2];
+	size_t len;
+
+	bzero(&req, sizeof(req));
+	req.hgu_req_prelen = prelen;
+	strlcpy(req.hgu_req_filename, filename,
+	    sizeof(req.hgu_req_filename));
+	iov_req[0].iov_base = &req;
+	iov_req[0].iov_len = sizeof(req);
+	iov_req[1].iov_base = pre;
+	iov_req[1].iov_len = prelen;
+	iov_rep.iov_base = &rep;
+	iov_rep.iov_len = sizeof(rep);
+	fdarray[0] = cap_new(in, CAP_FSTAT | CAP_READ | CAP_SEEK);
+	fdarray[1] = cap_new(out, CAP_FSTAT | CAP_WRITE | CAP_SEEK);
+	if (fdarray[0] == -1 || fdarray[1] == -1)
+		err(-1, "cap_new");
+	if (lch_rpc_rights(lcsp, PROXIED_GZ_UNCOMPRESS, iov_req, 1,
+	    fdarray, 2, &iov_rep, 1, &len, NULL, NULL) < 0)
+		err(-1, "lch_rpc_rights");
+	if (len != sizeof(rep))
+		errx(-1, "lch_rpc_rights len %zu", len);
+	if (gsizep != NULL)
+		*gsizep = rep.hgu_rep_gsize;
+	close(fdarray[0]);
+	close(fdarray[1]);
+	return (rep.hgu_rep_retval);
+}
+
+static void
+sandbox_gz_uncompress_buffer(struct lc_host *lchp, uint32_t opno,
+    uint32_t seqno, char *buffer, size_t len, int fd_in, int fd_out)
+{
+	struct host_gz_uncompress_req req;
+	struct host_gz_uncompress_rep rep;
+	struct iovec iov;
+	char *pre;
+
+	if (len != sizeof(req))
+		err(-1, "sandbox_gz_uncompress_buffer: len %zu", len);
+
+	bcopy(buffer, &req, sizeof(req));
+	pre = buffer + sizeof(req);
+	bzero(&rep, sizeof(rep));
+	rep.hgu_rep_retval = gz_uncompress(fd_in, fd_out, pre,
+	    req.hgu_req_prelen, &rep.hgu_rep_gsize, req.hgu_req_filename);
+	iov.iov_base = &rep;
+	iov.iov_len = sizeof(rep);
+	if (lcs_sendrpc(lchp, opno, seqno, &iov, 1) < 0)
+		err(-1, "lcs_sendrpc");
+}
+
+off_t
+gz_uncompress_wrapper(int in, int out, char *pre, size_t prelen,
+    off_t *gsizep, const char *filename)
+{
+
+	gzsandbox_initialize();
+	if (gzsandbox_enabled)
+		return (gz_uncompress_insandbox(in, out,  pre, prelen,
+		    gsizep, filename));
+	else
+		return (gz_uncompress(in, out, pre, prelen, gsizep,
+		    filename));
+}
+
+struct host_unbzip2_req {
+	size_t	hub_req_prelen;
+	/* ... followed by data ... */
+};
+
+struct host_unbzip2_rep {
+	off_t	hub_rep_bytes_in;
+	off_t	hub_rep_retval;
+};
+
+static off_t
+unbzip2_insandbox(int in, int out, char *pre, size_t prelen, off_t *bytes_in)
+{
+	struct host_unbzip2_req req;
+	struct host_unbzip2_rep rep;
+	struct iovec iov_req[2], iov_rep;
+	int fdarray[2];
+	size_t len;
+
+	bzero(&req, sizeof(req));
+	req.hub_req_prelen = prelen;
+	iov_req[0].iov_base = &req;
+	iov_req[0].iov_len = sizeof(req);
+	iov_req[1].iov_base = pre;
+	iov_req[1].iov_len = prelen;
+	iov_rep.iov_base = &rep;
+	iov_rep.iov_len = sizeof(rep);
+	fdarray[0] = cap_new(in, CAP_FSTAT | CAP_READ | CAP_SEEK);
+	fdarray[1] = cap_new(out, CAP_FSTAT | CAP_WRITE | CAP_SEEK);
+	if (fdarray[0] == -1 || fdarray[1] == -1)
+		err(-1, "cap_new");
+	if (lch_rpc_rights(lcsp, PROXIED_UNBZIP2, iov_req, 1,
+	    fdarray, 2, &iov_rep, 1, &len, NULL, NULL) < 0)
+		err(-1, "lch_rpc_rights");
+	if (len != sizeof(rep))
+		errx(-1, "lch_rpc_rights len %zu", len);
+	if (bytes_in != NULL)
+		*bytes_in = rep.hub_rep_bytes_in;
+	close(fdarray[0]);
+	close(fdarray[1]);
+	return (rep.hub_rep_retval);
+}
+
+static void
+sandbox_unbzip2_buffer(struct lc_host *lchp, uint32_t opno,
+    uint32_t seqno, char *buffer, size_t len, int fd_in, int fd_out)
+{
+	struct host_unbzip2_req req;
+	struct host_unbzip2_rep rep;
+	struct iovec iov;
+	char *pre;
+
+	if (len != sizeof(req))
+		err(-1, "sandbox_gz_uncompress_buffer: len %zu", len);
+
+	bcopy(buffer, &req, sizeof(req));
+	pre = buffer + sizeof(req);
+	bzero(&rep, sizeof(rep));
+	rep.hub_rep_retval = unbzip2(fd_in, fd_out, pre, req.hub_req_prelen,
+	    &rep.hub_rep_bytes_in);
+	iov.iov_base = &rep;
+	iov.iov_len = sizeof(rep);
+	if (lcs_sendrpc(lchp, opno, seqno, &iov, 1) < 0)
+		err(-1, "lcs_sendrpc");
+}
+
+off_t
+unbzip2_wrapper(int in, int out, char *pre, size_t prelen, off_t *bytes_in)
+{
+
+	gzsandbox_initialize();
+	if (gzsandbox_enabled)
+		return (unbzip2_insandbox(in, out, pre, prelen, bytes_in));
+	else
+		return (unbzip2(in, out, pre, prelen, bytes_in));
+}
+
+/*
+ * Main entry point for capability-mode 
+ */
+int
+cap_main(__unused int argc, __unused char *argv[])
+{
+	int fdarray[2], fdcount;
+	struct lc_host *lchp;
+	uint32_t opno, seqno;
+	u_char *buffer;
+	size_t len;
+
+	if (lcs_get(&lchp) < 0)
+		errx(-1, "libcapsicum sandbox binary");
+
+	while (1) {
+		fdcount = 2;
+		if (lcs_recvrpc_rights(lchp, &opno, &seqno, &buffer, &len,
+		    fdarray, &fdcount) < 0) {
+			if (errno == EPIPE)
+				exit(-1);
+			else
+				err(-1, "lcs_recvrpc_rights");
+		}
+		switch (opno) {
+		case PROXIED_GZ_COMPRESS:
+			if (fdcount != 2)
+				errx(-1, "sandbox_workloop: %d fds", fdcount);
+			sandbox_gz_compress_buffer(lchp, opno, seqno, buffer,
+			    len, fdarray[0], fdarray[1]);
+			close(fdarray[0]);
+			close(fdarray[1]);
+			break;
+
+		case PROXIED_GZ_UNCOMPRESS:
+			if (fdcount != 2)
+				errx(-1, "sandbox_workloop: %d fds", fdcount);
+			sandbox_gz_uncompress_buffer(lchp, opno, seqno,
+			    buffer, len, fdarray[0], fdarray[1]);
+			close(fdarray[0]);
+			close(fdarray[1]);
+			break;
+
+		case PROXIED_UNBZIP2:
+			if (fdcount != 2)
+				errx(-1, "sandbox_workloop: %d fds", fdcount);
+			sandbox_unbzip2_buffer(lchp, opno, seqno, buffer, len,
+			    fdarray[0], fdarray[1]);
+			close(fdarray[0]);
+			close(fdarray[1]);
+			break;
+
+		default:
+			errx(-1, "sandbox_workloop: unknown op %d", opno);
+		}
+		free(buffer);
+	}
+}
+
+#else /* NO_SANDBOX_SUPPORT */
+
+off_t
+gz_compress_wrapper(int in, int out, off_t *gsizep, const char *origname,
+    uint32_t mtime)
+{
+
+	return (gz_compress(in, out, gsizep, origname, mtime));
+}
+
+off_t
+gz_uncompress_wrapper(int in, int out, char *pre, size_t prelen,
+    off_t *gsizep, const char *filename)
+{
+
+	return (gz_uncompress(in, out, pre, prelen, gsizep, filename));
+}
+
+off_t
+unbzip2_wrapper(int in, int out, char *pre, size_t prelen, off_t *bytes_in)
+{
+
+	return (unbzip2(in, out, pre, prelen, bytes_in));
+}
+
+#endif /* !NO_SANDBOX_SUPPORT */

Index: usr.bin/gzip/gzip.c
===================================================================
--- usr.bin/gzip/gzip.c	(.../stable/8)	(revision 201781)
+++ usr.bin/gzip/gzip.c	(.../projects/capabilities8)	(revision 205872)
@@ -66,6 +66,8 @@
 #include <getopt.h>
 #include <time.h>
 
+#include "gzip.h"
+
 #ifndef PRIdOFF
 #define PRIdOFF PRId64
 #endif
@@ -184,7 +186,7 @@
 static	int	cflag;			/* stdout mode */
 static	int	dflag;			/* decompress mode */
 static	int	lflag;			/* list mode */
-static	int	numflag = 6;		/* gzip -1..-9 value */
+int	numflag = 6;			/* gzip -1..-9 value */
 
 #ifndef SMALL
 static	int	fflag;			/* force mode */
@@ -218,8 +220,6 @@
 #ifdef SMALL
 #define gz_compress(if, of, sz, fn, tm) gz_compress(if, of, sz)
 #endif
-static	off_t	gz_compress(int, int, off_t *, const char *, uint32_t);
-static	off_t	gz_uncompress(int, int, char *, size_t, off_t *, const char *);
 static	off_t	file_compress(char *, char *, size_t);
 static	off_t	file_uncompress(char *, char *, size_t);
 static	void	handle_pathname(char *);
@@ -248,10 +248,6 @@
 static	int	check_outfile(const char *outfile);
 #endif
 
-#ifndef NO_BZIP2_SUPPORT
-static	off_t	unbzip2(int, int, char *, size_t, off_t *);
-#endif
-
 #ifndef NO_COMPRESS_SUPPORT
 static	FILE 	*zdopen(int);
 static	off_t	zuncompress(FILE *, FILE *, char *, size_t, off_t *);
@@ -544,7 +540,7 @@
 #endif
 
 /* compress input to output. Return bytes read, -1 on error */
-static off_t
+off_t
 gz_compress(int in, int out, off_t *gsizep, const char *origname, uint32_t mtime)
 {
 	z_stream z;
@@ -711,7 +707,7 @@
  * uncompressed size written, and put the compressed sized read
  * into `*gsizep'.
  */
-static off_t
+off_t
 gz_uncompress(int in, int out, char *pre, size_t prelen, off_t *gsizep,
 	      const char *filename)
 {
@@ -1261,7 +1257,8 @@
 	} else
 		out = STDOUT_FILENO;
 
-	insize = gz_compress(in, out, &size, basename(file), (uint32_t)isb.st_mtime);
+	insize = gz_compress_wrapper(in, out, &size, basename(file),
+		    (uint32_t)isb.st_mtime);
 
 	(void)close(in);
 
@@ -1437,7 +1434,7 @@
 			goto lose;
 		}
 
-		size = unbzip2(fd, zfd, NULL, 0, NULL);
+		size = unbzip2_wrapper(fd, zfd, NULL, 0, NULL);
 	} else
 #endif
 
@@ -1505,7 +1502,7 @@
 			return -1;	/* XXX */
 		}
 
-		size = gz_uncompress(fd, zfd, NULL, 0, NULL, file);
+		size = gz_uncompress_wrapper(fd, zfd, NULL, 0, NULL, file);
 	}
 
 	if (close(fd) != 0)
@@ -1662,12 +1659,12 @@
 		break;
 #endif
 	case FT_GZIP:
-		usize = gz_uncompress(STDIN_FILENO, STDOUT_FILENO, 
-			      (char *)header1, sizeof header1, &gsize, "(stdin)");
+		usize = gz_uncompress_wrapper(STDIN_FILENO, STDOUT_FILENO,
+		    (char *)header1, sizeof header1, &gsize, "(stdin)");
 		break;
 #ifndef NO_BZIP2_SUPPORT
 	case FT_BZIP2:
-		usize = unbzip2(STDIN_FILENO, STDOUT_FILENO,
+		usize = unbzip2_wrapper(STDIN_FILENO, STDOUT_FILENO,
 				(char *)header1, sizeof header1, &gsize);
 		break;
 #endif
@@ -1736,8 +1733,9 @@
 #endif
 		mtime = (uint32_t)systime;
 	}
-	 		
-	usize = gz_compress(STDIN_FILENO, STDOUT_FILENO, &gsize, "", mtime);
+
+	usize = gz_compress_wrapper(STDIN_FILENO, STDOUT_FILENO, &gsize, "",
+	    mtime);
 #ifndef SMALL
         if (vflag && !tflag && usize != -1 && gsize != -1)
 		print_verbage(NULL, NULL, usize, gsize);
Index: usr.bin/gzip/gzip.h
===================================================================
--- usr.bin/gzip/gzip.h	(.../stable/8)	(revision 0)
+++ usr.bin/gzip/gzip.h	(.../projects/capabilities8)	(revision 205872)
@@ -0,0 +1,55 @@
+/*-
+ * Copyright (c) 2009-2010 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * WARNING: THIS IS EXPERIMENTAL SECURITY SOFTWARE THAT MUST NOT BE RELIED
+ * ON IN PRODUCTION SYSTEMS.  IT WILL BREAK YOUR SOFTWARE IN NEW AND
+ * UNEXPECTED WAYS.
+ * 
+ * This software was developed at the University of Cambridge Computer
+ * Laboratory with support from a grant from Google, Inc. 
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#ifndef _GZIP_H_
+#define	_GZIP_H_
+
+/*
+ * We need to forward the global variable 'numflag' to the sandbox as well as
+ * function arguments.
+ */
+extern int	numflag;
+
+off_t	gz_compress(int in, int out, off_t *gsizep, const char *origname,
+	    uint32_t mtime);
+off_t	gz_compress_wrapper(int in, int out, off_t *gsizep,
+	    const char *origname, uint32_t mtime);
+off_t	gz_uncompress(int in, int out, char *pre, size_t prelen,
+	    off_t *gsizep, const char *filename);
+off_t	gz_uncompress_wrapper(int in, int out, char *pre, size_t prelen,
+	    off_t *gsizep, const char *filename);
+off_t	unbzip2(int in, int out, char *pre, size_t prelen, off_t *bytes_in);
+off_t	unbzip2_wrapper(int in, int out, char *pre, size_t prelen,
+	    off_t *bytes_in);
+
+#endif /* !_GZIP_H_ */

Index: usr.bin/gzip/unbzip2.c
===================================================================
--- usr.bin/gzip/unbzip2.c	(.../stable/8)	(revision 201781)
+++ usr.bin/gzip/unbzip2.c	(.../projects/capabilities8)	(revision 205872)
@@ -33,7 +33,7 @@
 
 /* This file is #included by gzip.c */
 
-static off_t
+off_t
 unbzip2(int in, int out, char *pre, size_t prelen, off_t *bytes_in)
 {
 	int		ret, end_of_file, cold = 0;
